data {
  int<lower=0> N;   // number of data items
  int<lower=0> D;   // number of predictors
  matrix[N, D] x;   // predictor matrix
  int<lower=0,upper=1> y[N];      // outcome vector
  real<lower=0> sigma;
}
parameters {
  vector[D] beta;       // coefficients for predictors
}
model {
  y ~ bernoulli_logit(x * beta);  // likelihood
  beta ~ normal(0, sigma);
}
