data {
  int<lower=0> N;   // number of data items
  int<lower=0> D;   // number of predictors
  matrix[N, D] x;   // predictor matrix
  vector[N] y;      // outcome vector
  real<lower=0> sigma;  // error scale
  real<lower=0> lambda;
}
parameters {
  vector[D] beta;       // coefficients for predictors
}
model {
  y ~ normal(x * beta, sigma);  // likelihood
  beta ~ normal(0, lambda);
}
